
using System;
using System.IO;

using ICSharpCode.SharpZipLib;
using ICSharpCode.SharpZipLib.Zip;    

class MainClass
{
	
	public static void Main(string[] args)
{

		string[] fInfo = args[0].Split(';');

		//if (!Directory.Exists(fInfo[0]))
		//{
		//    System.Windows.Forms.MessageBox.Show(fInfo[0], "Info", System.Windows.Forms.MessageBoxButtons.OK);
		//    return;
		//}

		//string[] fInfo = new string[3];
		//fInfo[0] = @"C:\!" + "\\";
		//fInfo[1] = "ServiceAufzeichnung";
		//fInfo[2] = "cr3"; 

		try
		{

			//im Verzeichnis alle aktuellen Dateien suchen
			
			string fileName = fInfo[1];
			string zipName = fInfo[0] + fileName + ".zip";
			string[] Files = System.IO.Directory.GetFiles(fInfo[0]);
			

			string zipFilesStr = "";

			for (int iIndex = 0; iIndex < Files.Length; iIndex++)
			{
			    string filesName = Path.GetFileName(Files[iIndex]) ;
			    
				for (int fIndex = 2; fIndex < fInfo.Length; fIndex++)
				{
					string fInfoName = fileName + fInfo[fIndex];
					if (filesName == fInfoName)
					{
						if (zipFilesStr != "")
							zipFilesStr += ";" + Files[iIndex];
						else
							zipFilesStr += Files[iIndex];
					}
				}
			}

			string[] filenames = zipFilesStr.Split(';');

			//System.Windows.Forms.MessageBox.Show(zipName,"Info",System.Windows.Forms.MessageBoxButtons.OK);    
			
			// 'using' statements guarantee the stream is closed properly which is a big source
			// of problems otherwise.  Its exception safe as well which is great.
			using (ZipOutputStream s = new ZipOutputStream(File.Create(zipName)))
			{
			
				s.SetLevel(0); // 0 - store only to 9 - means best compression
		
				byte[] buffer = new byte[4096];
				
				foreach (string file in filenames) {
					
					// Using GetFileName makes the result compatible with XP
					// as the resulting path is not absolute.
					ZipEntry entry = new ZipEntry(Path.GetFileName(file));
					
					// Setup the entry data as required.
					
					// Crc and size are handled by the library for seakable streams
					// so no need to do them here.

					// Could also use the last write time or similar for the file.
					entry.DateTime = DateTime.Now;
					s.PutNextEntry(entry);
					
					using ( FileStream fs = File.OpenRead(file) ) {
		
						// Using a fixed size buffer here makes no noticeable difference for output
						// but keeps a lid on memory usage.
						int sourceBytes;
						do {
							sourceBytes = fs.Read(buffer, 0, buffer.Length);
							s.Write(buffer, 0, sourceBytes);
						} while ( sourceBytes > 0 );
					}
				}
				
				// Finish/Close arent needed strictly as the using statement does this automatically
				
				// Finish is important to ensure trailing information for a Zip file is appended.  Without this
				// the created file would be invalid.
				s.Finish();
				
				
				// Close is important to wrap things up and unlock the file.
				s.Close();
			}
		}
		catch(Exception ex)
		{
			Console.WriteLine("Exception during processing {0}", ex);
			
			// No need to rethrow the exception as for our purposes its handled.
		}
	}
}
